
// -----------------------------------------------------------------------------------------
//  Trying to do a best hilight (not working)
// -----------------------------------------------------------------------------------------
// https://groups.google.com/g/blockly/c/Zn-0UIBiOfk
// https://groups.google.com/g/blockly/c/q4iUwImOIuM
// ------------------------------------------------------------------ HILIGHT BLOCK SELECTED
//Blockly.BlockSvg.prototype.setHighlighted = function(highlighted) 
//{
//    if (!this.rendered) return;
//    if (highlighted) 
//    {
//        this.addSelect();
//        //this.svgPath_.setAttribute('filter', 'url(#' + this.workspace.options.embossFilterId + ')');
//        //this.svgPathLight_.style.display = 'none';
//    } 
//    else 
//    {
//        this.removeSelect();
//        //Blockly.utils.removeAttribute(this.svgPath_, 'filter');
//        //delete this.svgPathLight_.style.display;
//    }
//};

// ------------------------------------------------------------------ HILIGHT BLOCK
//var HilightedBlock;
function highlightBlock(id)
{
    //HilightedBlock = workspace.getBlockById(id).type;     
    workspace.highlightBlock(id);
    HighlightPause = true;
    ExecutingWaitBlock = false;
}

// ------------------------------------------------------------------ INIT TOOLBOX and WORKSPACE
var workspace;
function initToolboxAndWorkspace(toolboxXML, workspaceXML) 
{
    workspace = 
    Blockly.inject
    (
        'blocklyDiv', 
        {
            media: '../../media/', toolbox: toolboxXML, 
            move:
            {
                scrollbars: 
                {
                    horizontal: true,
                    vertical: true
                },
                drag: true,
                wheel: true
            }
        }
    );
    var wx = Blockly.Xml.textToDom(workspaceXML);
    Blockly.Xml.domToWorkspace(wx, workspace);
    workspace.clearUndo();
}

// ------------------------------------------------------------------ Get WORKSPACE as text
function getWorkspaceAsText()
{
    var dom = Blockly.Xml.workspaceToDom(workspace);
    var txt = Blockly.Xml.domToPrettyText(dom);
    return txt;
}

// ------------------------------------------------------------------ Get TOOLBOX as text
function getToolboxAsText()
{
    var txt = workspace.options.languageTree;
    return txt;
}

// ------------------------------------------------------------------ Get JS-CODE as text
function getBlocklyCode()
{
    var code = Blockly.JavaScript.workspaceToCode(workspace);
    return code;
}

// ------------------------------------------------------------------ LIST VARS
function listVars() 
{
    var s = '';
    var v = workspace.getAllVariables();
    for (var i = 0; i < v.length; i++)
    {
        var name = v[i].name;
        var value = globalInterpreter.globalScope.object.properties[name];
        value = value ? value.toString() : '';
        s = s + name + ' = ' + value + '\r\n';
    }
    return s;
}

// ------------------------------------------------------------------ LIST VARS ALTERNATIVE
//function listVars() 
//{
//    var s = '';
//    workspace.getBlocksByType("variables_set", false).forEach(function (item) 
//    {
//        var name = item.getField('VAR').getText();
//        var value = globalInterpreter.globalObject.properties[name];
//        value = value ? value.toString() : '';
//        s = s + name + ' = ' + value + '\r\n';
//    });
//    return s;
//}


// ------------------------------------------------------------------ GENERATE LATEST-CODE
var globalCode;
function generateCode()
{
    Blockly.JavaScript.STATEMENT_PREFIX = 'highlightBlock(%1);\n';
    Blockly.JavaScript.addReservedWords('highlightBlock');
    globalCode = Blockly.JavaScript.workspaceToCode(workspace);
}


// ------------------------------------------------------------------ ADD CHANGE LISTENER
// https://developers.google.com/blockly/guides/configure/web/events
function addChangeListener()
{
    WorkspaceChanged = false;
    workspace.addChangeListener
    (
        function (event)
        {
            if (event.type == Blockly.Events.CLICK) 
            {
                WorkspaceChanged = true;
            }
            if (event.type == Blockly.Events.CHANGE || 
                event.type == Blockly.Events.CREATE || 
                event.type == Blockly.Events.DELETE || 
                event.type == Blockly.Events.MOVE) 
            {
                WorkspaceChanged = true;
                chrome.webview.postMessage('block_changed');
            }

            // DEBUG EVENT-TYPE
            //chrome.webview.postMessage(event.type);
        }
    );
}





// ======================================================================================
//   INIT INTERPRETER / CREATE AND ACTIVATE THREAD
// --------------------------------------------------------------------------------------
//  Create an interpreter whose global scope will be the cross-thread global.
// ======================================================================================

var globalInterpreter = new Interpreter('', initGlobal);
var threads = [];

function clearInterpreterThreads()
{
    threads = [];
}

function initInterpreter()
{
    addChangeListener();
    generateCode();
    createAndActivateThread(globalCode);   
}

function createAndActivateThread(code) 
{
    var interpreter = new Interpreter('');
    interpreter.getStateStack()[0].scope = globalInterpreter.getGlobalScope();
    interpreter.appendCode(code);
    threads.push(interpreter.getStateStack());
    globalInterpreter.setStateStack(threads[threads.length-1]);
}


// ======================================================================================
//   RUN STEPS UNTIL HILIGHTED BLOCK (Debug = 600 uS/line - Release = 300 uS/line)
// ======================================================================================
var ExecutingWaitBlock = false;
var WorkspaceChanged = false;
var HighlightPause = false;
var RunningManualStep;  // If doing manual steps then exit immediately from Wait-Blocks

function runStepsUntilHilight(ManualStep) 
{
    RunningManualStep = ManualStep;
    HighlightPause = false;
    do 
    {
        if (!globalInterpreter.step()) 
        {
            threads.pop(); 
            globalInterpreter.setStateStack(threads[threads.length - 1]);
            if (threads.length == 0) 
            {
                workspace.highlightBlock(null);
                return 'PROGRAM_END';
            }
        }

        if (WorkspaceChanged) 
        {
            WorkspaceChanged = false;
            workspace.highlightBlock(null);
            return 'PROGRAM_CHANGED';
        }

    } while (!HighlightPause && !ExecutingWaitBlock);
    return '';
}


// ======================================================================================
//   ENTRY POINTS TO RUN BLOCKS
// ======================================================================================

function runFunctionBlock(functionName)
{
    createAndActivateThread(functionName + '();');
}

function runInterpreterStepManual() 
{
    return runStepsUntilHilight('true'); 
}

function runInterpreterStep() 
{
    return runStepsUntilHilight('false');  
}


// --------------------------------------------------------------------------------------
//  Not working example of JavaScript Loop with SetTimeout(name, 0)
// --------------------------------------------------------------------------------------
//function runInterpreterStep() 
//{
//    var retval = runStepsUntilHilight('false'); 
//    if (retval != '') 
//    {
//        return retval;
//    }
//    setTimeout(runInterpreterStep, 0);
//}

// --------------------------------------------------------------------------------------
//   LINKS ABOUT BLOCKLY INTERRUPTS
// --------------------------------------------------------------------------------------
// https://groups.google.com/g/blockly/c/39FtlxbNUYk
// https://github.com/NeilFraser/JS-Interpreter/issues/147
// https://github.com/NeilFraser/JS-Interpreter/blob/master/docs.html
// https://codepen.io/gregdyke/pen/rNvXdBG
// --------------------------------------------------------------------------------------


// --------------------------------------------------------------------------------------
//  TRYING TO USE SYSTEM CLIPBOARD
//
// https://groups.google.com/g/blockly/c/9ndDENTrLzw
// --------------------------------------------------------------------------------------
function Builder_copy() 
{
             beep(1000, 100);

    var xmlDom = Blockly.Xml.workspaceToDom(Blockly.mainWorkspace);
    var xmlText = Blockly.Xml.domToPrettyText(xmlDom);
   
    localStorage.setItem("Blockly.xml", xmlText);
    console.log(Blockly.mainWorkspace);
};

//function Builder_paste() {
//    var xmlText = localStorage.getItem("Blockly.xml");
//    if (xmlText) {
//        xmlDom = Blockly.Xml.textToDom(xmlText);
//        Blockly.Xml.domToWorkspace(xmlDom, Blockly.mainWorkspace);
//    }
//};


//function getWorkspaceXML() 
//{
//    if (!Blockly.selected) return '';
//    if (Blockly.selected == '') return '';
//    var xmlDom = Blockly.Xml.blockToDom(Blockly.selected);
//    // add the <xml> tags
//    var xmlText = '<xml xmlns="http://www.w3.org/1999/xhtml">' + Blockly.Xml.domToPrettyText(xmlDom) + '</xml>';
//    return xmlText;
//};



function beep(freq, duration)
{
    var t1 = freq ? freq.toString() : '0';
    var t2 = duration ? duration.toString() : '0';
    var dummy = chrome.webview.hostObjects.sync.dotnet.SetValue('Beep ' + t1 + ' ' + t2);
}



